% This illustrates pDRUR for a simple 2D dataset projecting to 1D

% Dataset
N=300; X=linspace(0,10,N)'; Xn=X+randn(size(X));
Y=[X.*sin(X) X.*cos(X)]; Y=Y+randn(size(Y))/2;
figure(1); plot(Y(:,1),Y(:,2),'bo'); set(gca,'DataAspectRatio',[1 1 1]);

% pDRUR
[XX,ff,FF,E] = drur(Y,Xn,{'rbf',10,[],0.1},{'rbf',10,[],0.1},[],10);
%[XX,ff,FF,E] = drur(Y,Xn,{'linf',1e-5},{'linf',1e-5},[],10);
%[XX,ff,FF,E] = drur(Y,Xn,{'mlp',10},{'mlp',10},[],10);

% Results after each iteration
for i=1:length(XX)
  Fcn=str2func(FF{i}.type); fcn=str2func(ff{i}.type);
  fX = fcn(linspace(min(XX{i}),max(XX{i}),N)',ff{i}); FY = Fcn(Y,FF{i});
  % Axis
  tmp = [Y;fX]; tmpm = min(tmp,[],1); tmpM = max(tmp,[],1); tmpr = tmpM-tmpm;
  ax=[tmpm(1) tmpM(1) tmpm(2) tmpM(2)]+0.1*[-tmpr(1) tmpr(1) -tmpr(2) tmpr(2)];
  ax=round(ax*100)/100;

  % 2D dataset, trace of f(x), contours of F(y)
  figure(1); plot(Y(:,1),Y(:,2),'bo',fX(:,1),fX(:,2),'r+-');
  y1 = linspace(ax(1),ax(2),50); y2 = linspace(ax(3),ax(4),50);
  [Y1,Y2] = meshgrid(y1,y2); ZZ = reshape(Fcn([Y1(:) Y2(:)],FF{i}),50,50);
  hold on; contour(Y1,Y2,ZZ,100); hold off; axis(ax);
  title(['i=' num2str(i) ', E=' num2str(E(i))]); xlabel('y_1'); ylabel('y_2');
  set(gca,'DataAspectRatio',[1 1 1]);
  
  % 1D embedding: x and F(y)
  figure(2); plot(1:N,XX{i},'bo-',1:N,FY,'r+-');
  title(['i=' num2str(i) ', E=' num2str(E(i))]); xlabel('n'); ylabel('x_n');
  
  pause;
end

