% [Y,J] = mlp(X,f) Value and Jacobian wrt x of MLP f(x)
%
% See mlptrain.
%
% In:
%   X: NxL matrix, N L-dim data points rowwise.
%   f: (struct) the MLP.
% Out:
%   Y: NxD matrix, N D-dim outputs Y = f(X).
%   J: DxL Jacobian matrix (assumes N=1 input only).

% Copyright (c) 2009 by Miguel A. Carreira-Perpinan

function [Y,J] = mlp(X,f)

N = size(X,1);

[s,ds] = sigmoid(f.W1*[X';ones(1,N)]);
Y = (f.W2*[s;ones(1,N)])';
if nargout>1 J = f.W2(:,1:end-1)*(diag(sparse(ds))*f.W1(:,1:end-1)); end

